Index: /LMDZ5/branches/testing/libf/phylmd/concvl.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2220)
@@ -15,5 +15,6 @@
                   dd_t, dd_q, lalim_conv, wght_th, &                 ! RomP
                   evap, ep, epmlmMm, eplaMm, &                       ! RomP
-                  wdtrainA, wdtrainM, wght)                          ! RomP+RL
+                  wdtrainA, wdtrainM, wght, qtc, sigt, &
+                  tau_cld_cv, coefw_cld_cv)                           ! RomP+RL, AJ
 !RomP <<<
 ! **************************************************************
@@ -29,4 +30,5 @@
   USE dimphy
   USE infotrac, ONLY: nbtr
+  USE phys_local_var_mod, ONLY: omega
   IMPLICIT NONE
 ! ======================================================================
@@ -135,4 +137,6 @@
   REAL dplcldt(klon), dplcldr(klon)
   REAL qcondc(klon, klev)
+  REAL qtc(klon, klev)
+  REAL sigt(klon, klev)
   REAL wd(klon)
   REAL plim1(klon), plim2(klon), asupmax(klon, klev)
@@ -141,4 +145,5 @@
   REAL sigd(klon)
   REAL zx_t, zdelta, zx_qs, zcor
+  REAL tau_cld_cv, coefw_cld_cv
 
 !   INTEGER iflag_mix
@@ -203,4 +208,5 @@
 !$OMP THREADPRIVATE(itap, igout)
 
+
   include "YOMCST.h"
   include "YOMCST2.h"
@@ -398,5 +404,5 @@
                     t, q, qs, t_wake, q_wake, qs_wake, s_wake, u, v, tra, &
                     em_p, em_ph, &
-                    Ale, Alp, &
+                    Ale, Alp, omega, &
                     em_sig1feed, em_sig2feed, em_wght, &
                     iflag, d_t, d_q, d_u, d_v, d_tra, rain, kbas, ktop, &
@@ -411,5 +417,6 @@
                     da, phi, mp, phi2, d1a, dam, sij, wght, &           ! RomP+RL
                     clw, elij, evap, ep, epmlmMm, eplaMm, &             ! RomP+RL
-                    wdtrainA, wdtrainM)                                 ! RomP
+                    wdtrainA, wdtrainM, qtc, sigt, &
+                    tau_cld_cv, coefw_cld_cv)                           ! RomP,AJ
 !AC!+!RomP+jyg
   END IF
Index: /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2220)
@@ -15,5 +15,5 @@
        solarlong0,seuil_inversion, &
        fact_cldcon, facttemps,ok_newmicro,iflag_radia,&
-       iflag_cldcon, &
+       iflag_cldth, &
        iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
        ok_ade, ok_aie, ok_cdnc, aerosol_couple, &
@@ -81,5 +81,5 @@
     REAL                 :: bl95_b0, bl95_b1
     real                 :: fact_cldcon, facttemps,ratqsbas,ratqshaut,tau_ratqs
-    integer              :: iflag_cldcon
+    integer              :: iflag_cldth
     integer              :: iflag_ratqs
 
@@ -101,4 +101,8 @@
     REAL,SAVE           :: freq_COSP_omp
     real,SAVE           :: fact_cldcon_omp, facttemps_omp,ratqsbas_omp
+    real,SAVE           :: tau_cld_cv_omp, coefw_cld_cv_omp
+    integer,SAVE        :: iflag_cld_cv_omp
+
+
     real,SAVE           :: ratqshaut_omp
     real,SAVE           :: tau_ratqs_omp
@@ -107,5 +111,5 @@
     integer,SAVE        :: iflag_rrtm_omp
     integer,SAVE        :: NSW_omp
-    integer,SAVE        :: iflag_cldcon_omp, ip_ebil_phy_omp
+    integer,SAVE        :: iflag_cldth_omp, ip_ebil_phy_omp
     integer,SAVE        :: iflag_ratqs_omp
 
@@ -132,4 +136,5 @@
     integer,SAVE :: iflag_coupl_omp,iflag_clos_omp,iflag_wake_omp
     integer,SAVE :: iflag_cvl_sigd_omp
+    REAL, SAVE :: coef_clos_ls_omp
     REAL, SAVE :: supcrit1_omp, supcrit2_omp
     INTEGER, SAVE :: iflag_mix_omp
@@ -886,11 +891,45 @@
 
     !
-    !Config Key  = iflag_cldcon 
+    !Config Key  = iflag_cldth 
     !Config Desc =  
     !Config Def  = 1
     !Config Help = 
     !
-    iflag_cldcon_omp = 1
-    call getin('iflag_cldcon',iflag_cldcon_omp)
+    iflag_cldth_omp = 1
+! On lit deux fois avec l'ancien et le nouveau nom 
+! pour assurer une retrocompatiblite.
+! A abandonner un jour
+    call getin('iflag_cldcon',iflag_cldth_omp)
+    call getin('iflag_cldth',iflag_cldth_omp)
+
+    !
+    !Config Key  = iflag_cld_cv
+    !Config Desc =
+    !Config Def  = 1
+    !Config Help =
+    !
+    iflag_cld_cv_omp = 1
+    call getin('iflag_cld_cv',iflag_cld_cv_omp)
+
+    !
+    !Config Key  = tau_cld_cv
+    !Config Desc =
+    !Config Def  = 10.
+    !Config Help =
+    !
+    tau_cld_cv_omp = 10.
+    call getin('tau_cld_cv',tau_cld_cv_omp)
+
+    !
+    !Config Key  = coefw_cld_cv
+    !Config Desc =
+    !Config Def  = 0.1
+    !Config Help =
+    !
+    coefw_cld_cv_omp = 0.1
+    call getin('coefw_cld_cv',coefw_cld_cv_omp)
+
+
+
 
     !
@@ -1343,4 +1382,13 @@
     iflag_clos_omp = 1
     call getin('iflag_clos',iflag_clos_omp)
+    !
+    !Config Key  = coef_clos_ls
+    !Config Desc =  
+    !Config Def  = 0
+    !Config Help = 
+    !
+    coef_clos_ls_omp = 0.
+    call getin('coef_clos_ls',coef_clos_ls_omp)
+
     !
     !Config Key  = iflag_cvl_sigd
@@ -1925,5 +1973,8 @@
     iflag_rrtm = iflag_rrtm_omp
     NSW = NSW_omp
-    iflag_cldcon = iflag_cldcon_omp
+    iflag_cldth = iflag_cldth_omp
+    iflag_cld_cv = iflag_cld_cv_omp
+    tau_cld_cv = tau_cld_cv_omp
+    coefw_cld_cv = coefw_cld_cv_omp
     iflag_ratqs = iflag_ratqs_omp
     ip_ebil_phy = ip_ebil_phy_omp
@@ -1946,4 +1997,5 @@
     iflag_clos = iflag_clos_omp
     iflag_wake = iflag_wake_omp
+    coef_clos_ls = coef_clos_ls_omp
     alp_offset = alp_offset_omp
     iflag_cvl_sigd = iflag_cvl_sigd_omp
@@ -2076,5 +2128,8 @@
     write(lunout,*)' reevap_ice = ', reevap_ice
     write(lunout,*)' iflag_pdf = ', iflag_pdf
-    write(lunout,*)' iflag_cldcon = ', iflag_cldcon
+    write(lunout,*)' iflag_cldth = ', iflag_cldth
+    write(lunout,*)' iflag_cld_cv = ', iflag_cld_cv
+    write(lunout,*)' tau_cld_cv = ', tau_cld_cv
+    write(lunout,*)' coefw_cld_cv = ', coefw_cld_cv
     write(lunout,*)' iflag_radia = ', iflag_radia
     write(lunout,*)' iflag_rrtm = ', iflag_rrtm
@@ -2135,4 +2190,5 @@
     write(lunout,*)' iflag_thermals_closure = ', iflag_thermals_closure
     write(lunout,*)' iflag_clos = ', iflag_clos
+    write(lunout,*)' coef_clos_ls = ', coef_clos_ls
     write(lunout,*)' type_run = ',type_run 
     write(lunout,*)' ok_cosp = ',ok_cosp
Index: /LMDZ5/branches/testing/libf/phylmd/convect3.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/convect3.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/convect3.F90	(revision 2220)
@@ -17,5 +17,5 @@
   USE dimphy
   USE infotrac, ONLY: nbtr
-
+  IMPLICIT NONE
   include "dimensions.h"
   INTEGER na
@@ -73,5 +73,15 @@
 
 
-
+  REAL :: cpv,cl,cpvmcl,eps,alv0,rdcp,pbcrit,ptcrit,sigd,spfac
+  REAL :: tau,beta,alpha,dtcrit,dtovsh,ahm,rm,um,vm,dphinv
+  REAL :: a2,x,tvx,tvy,plcl,pden,dpbase,tvpbase,tvbase,tdif
+  REAL :: ath1,ath,delti,deltap,dcape,dlnp,sigold,dtmin,fac,w
+  REAL :: amu,rti,cpd,bf2,anum,denom,dei,altem,cwat,stemp,qp
+  REAL :: scrit,alt,smax,asij,wgh,sjmax,sjmin,smid,delp,delm
+  REAL :: asum,bsum,csum,wflux,tinv,wdtrain,awat,afac,afac1,afac2
+  REAL :: bfac,pr1,pr2,sigt,b6,c6,revap,tevap,delth,amfac,amp2
+  REAL :: xf,tf,af,bf,fac2,ur,sru,d,ampmax,dpinv,am,amde,cpinv
+  REAL :: amp1,ad,rat,ax,bx,cx,dx,ex,dsum
+  INTEGER :: nk,i,j,nopt,jn,k,im,jm,n
 
   REAL dnwd0(nd) !  precipitation driven unsaturated downdraft flux
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_inicp.F90	(revision 2220)
@@ -9,5 +9,5 @@
   ! modified by :                                               *
   ! **************************************************************
-
+  IMPLICIT NONE
   include "YOMCST2.h"
 
@@ -19,4 +19,5 @@
 
   REAL qcoef1, qcoef2, qff, qfff, qmix, rmix, qmix1, rmix1, qmix2, rmix2, f
+  REAL :: sumcoef,sigma,aire,pdf,mu,df,ff
 
   qcoef1(f) = tanh(f/gammas)
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_inip.F90	(revision 2220)
@@ -1,19 +1,47 @@
 SUBROUTINE cv3_inip()
-  ! **************************************************************
-  ! *
-  ! CV3_INIP Lecture des choix de lois de probabilité de mélange*
-  ! et calcul de leurs coefficients normalisés.        *
-  ! *
-  ! written by   : Jean-Yves Grandpeix, 06/06/2006, 19.39.27    *
-  ! modified by :                                               *
-  ! **************************************************************
+  ! *******************************************************************
+  ! *                                                                  *
+  ! CV3_INIP Input = choice of mixing probability laws                 *
+  !          Output = normalized coefficients of the probability laws. *
+  ! *                                                                  *
+  ! written by   : Jean-Yves Grandpeix, 06/06/2006, 19.39.27           *
+  ! modified by :                                                      *
+  ! *******************************************************************
+!
+!----------------------------------------------
+!  INPUT (from Common YOMCST2 in "YOMCST2.h") : 
+! iflag_mix
+! gammas    
+! alphas
+! betas
+! Fmax
+! scut
+!
+!----------------------------------------------
+!  INPUT/OUTPUT (from and to Common YOMCST2 in "YOMCST2.h") : 
+! qqa1
+! qqa2
+!
+!----------------------------------------------
+!  OUTPUT (to Common YOMCST2 in "YOMCST2.h") :
+! Qcoef1max
+! Qcoef2max
+!
+!----------------------------------------------
+
+  IMPLICIT NONE
 
   include "YOMCST2.h"
 
-  ! INTEGER iflag_mix
   include 'iniprint.h'
 
-  CHARACTER (LEN=20) :: modname = 'cv3_inip'
-  CHARACTER (LEN=80) :: abort_message
+!----------------------------------------------
+! Local variables :
+   CHARACTER (LEN=20) :: modname = 'cv3_inip'
+   CHARACTER (LEN=80) :: abort_message
+
+   REAL               :: sumcoef
+   REAL               :: sigma, aire, pdf, mu, df
+   REAL               :: ff
 
 
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2220)
@@ -1,4 +1,5 @@
 
 ! $Id$
+
 
 
@@ -2763,5 +2764,5 @@
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
                      tls, tps, qcondc, wd, &
-                     ftd, fqd)
+                     ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
 
   IMPLICIT NONE
@@ -2800,4 +2801,5 @@
 !input/output:
       INTEGER iflag(nloc)
+      REAL,INTENT(in) :: tau_cld_cv, coefw_cld_cv
 !
 !outputs:
@@ -2811,4 +2813,5 @@
       REAL tls(nloc, nd), tps(nloc, nd)
       REAL qcondc(nloc, nd) ! cld
+      REAL qtc(nloc,nd), sigt(nloc,nd) ! cld
       REAL wd(nloc) ! gust
       REAL cbmf(nloc)
@@ -2830,5 +2833,6 @@
       REAL qcond(nloc, nd), nqcond(nloc, nd), wa(nloc, nd) ! cld
       REAL siga(nloc, nd), sax(nloc, nd), mac(nloc, nd) ! cld
-
+      REAL sument(nloc), sigment(nloc,nd), qtment(nloc,nd) ! cld
+      REAL qnk(nloc)
       REAL sumdq !jyg
 ! 
@@ -2861,4 +2865,8 @@
       qcondc(il, i) = 0.0 ! cld
       qcond(il, i) = 0.0 ! cld
+      qtc(il, i) = 0.0 ! cld
+      qtment(il, i) = 0.0 ! cld
+      sigment(il, i) = 0.0 ! cld
+      sigt(il, i) = 0.0 ! cld
       nqcond(il, i) = 0.0 ! cld
     END DO
@@ -3234,5 +3242,6 @@
 ! (saturated updrafts resulting from mixing)                                   ! cld
           qcond(il, i) = qcond(il, i) + (elij(il,k,i)-awat(il))                ! cld
-          nqcond(il, i) = nqcond(il, i) + 1. ! cld
+          qtment(il, i) = qtment(il, i) + qent(il,k,i)                         ! cld
+          nqcond(il, i) = nqcond(il, i) + 1.                                   ! cld
         END IF ! i
       END DO
@@ -3310,5 +3319,6 @@
 ! (saturated downdrafts resulting from mixing)                                 ! cld
           qcond(il, i) = qcond(il, i) + elij(il, k, i)                         ! cld
-          nqcond(il, i) = nqcond(il, i) + 1. ! cld
+          qtment(il, i) = qent(il,k,i) + qtment(il,i)                          ! cld
+          nqcond(il, i) = nqcond(il, i) + 1.                                   ! cld
         END IF ! cld
       END DO ! cld
@@ -3319,4 +3329,5 @@
       IF (i<=inb(il) .AND. nent(il,i)==0 .AND. iflag(il)<=1) THEN              ! cld
         qcond(il, i) = qcond(il, i) + (1.-ep(il,i))*clw(il, i)                 ! cld
+        qtment(il, i) = qent(il,k,i) + qtment(il,i)                          ! cld
         nqcond(il, i) = nqcond(il, i) + 1.                                     ! cld
       END IF                                                                   ! cld
@@ -3326,4 +3337,5 @@
       IF (i<=inb(il) .AND. nqcond(il,i)/=0 .AND. iflag(il)<=1) THEN            ! cld
         qcond(il, i) = qcond(il, i)/nqcond(il, i)                              ! cld
+        qtment(il, i) = qtment(il,i)/nqcond(il, i)                             ! cld
       END IF                                                                   ! cld
     END DO
@@ -3788,18 +3800,53 @@
       END IF                                                         ! cld
     END DO                                                           ! cld
-  END DO                                                             ! cld
-
-  DO i = 1, nl                                                       ! cld
+  END DO  
+                                                           ! cld
+  DO i = 1, nl  
+
+! 14/01/15 AJ je remets les parties manquantes cf JYG
+! Initialize sument to 0
+
+    DO il = 1,ncum
+     sument(il) = 0.
+    ENDDO
+
+! Sum mixed mass fluxes in sument
+
+    DO k = 1,nl
+      DO il = 1,ncum
+        IF  (k<=inb(il) .AND. i<=inb(il) .AND. iflag(il)<=1) THEN   ! cld
+          sument(il) =sument(il) + abs(ment(il,k,i))
+        ENDIF
+      ENDDO     ! il
+    ENDDO       ! k
+
+! 14/01/15 AJ delta n'a rien à faire là...                                                 
     DO il = 1, ncum                                                  ! cld
       IF (wa(il,i)>0.0 .AND. iflag(il)<=1) &                         ! cld
-        siga(il, i) = mac(il, i)/wa(il, i) &                         ! cld
-        *rrd*tvp(il, i)/p(il, i)/100./delta                          ! cld
+        siga(il, i) = mac(il, i)/(coefw_cld_cv*wa(il, i)) &          ! cld
+        *rrd*tvp(il, i)/p(il, i)/100.                                ! cld
+
       siga(il, i) = min(siga(il,i), 1.0)                             ! cld
-! IM cf. FH                                                          
+
+! IM cf. FH 
+! 14/01/15 AJ ne correspond pas à ce qui a été codé par JYG et SB           
+                                                         
       IF (iflag_clw==0) THEN                                         ! cld
         qcondc(il, i) = siga(il, i)*clw(il, i)*(1.-ep(il,i)) &       ! cld
           +(1.-siga(il,i))*qcond(il, i)                              ! cld
+
+
+        sigment(il,i)=sument(il)*tau_cld_cv/(ph(il,i)-ph(il,i+1))    ! cld
+        sigment(il, i) = min(1.e-4+sigment(il,i), 1.0 - siga(il,i))  ! cld
+        qtc(il, i) = (siga(il,i)*qnk(il)+sigment(il,i)*qtment(il,i)) & ! cld
+                     /(siga(il,i)+sigment(il,i))                     ! cld
+        sigt(il,i) = sigment(il, i) + siga(il, i)
+
+!        qtc(il, i) = siga(il,i)*qnk(il)+(1.-siga(il,i))*qtment(il,i) ! cld
+!     print*,'BIGAUSSIAN CONV',siga(il,i),sigment(il,i),qtc(il,i)  
+      		
       ELSE IF (iflag_clw==1) THEN                                    ! cld
         qcondc(il, i) = qcond(il, i)                                 ! cld
+        qtc(il,i) = qtment(il,i)                                     ! cld
       END IF                                                         ! cld
 
Index: /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2220)
@@ -4,8 +4,8 @@
     th1_wake, tra1, h1, lv1, lf1, cpn1, p1, ph1, tv1, tp1, tvp1, clw1, &
     h1_wake, lv1_wake, lf1_wake, cpn1_wake, tv1_wake, sig1, w01, ptop21, &
-    ale1, alp1, iflag, nk, icb, icbs, plcl, tnk, qnk, gznk, hnk, unk, vnk, &
+    ale1, alp1, omega1, iflag, nk, icb, icbs, plcl, tnk, qnk, gznk, hnk, unk, vnk, &
     wghti, pbase, buoybase, t, q, qs, t_wake, q_wake, qs_wake, s_wake, u, v, &
     gz, th, th_wake, tra, h, lv, lf, cpn, p, ph, tv, tp, tvp, clw, h_wake, &
-    lv_wake, lf_wake, cpn_wake, tv_wake, sig, w0, ptop2, ale, alp)
+    lv_wake, lf_wake, cpn_wake, tv_wake, sig, w0, ptop2, ale, alp, omega)
   ! **************************************************************
   ! *
@@ -40,4 +40,5 @@
   REAL sig1(len, nd), w01(len, nd), ptop21(len)
   REAL ale1(len), alp1(len)
+  REAL omega1(len,nd)
 
   ! outputs:
@@ -60,4 +61,5 @@
   REAL sig(len, nd), w0(len, nd), ptop2(len)
   REAL ale(len), alp(len)
+  REAL omega(len,nd)
 
   ! local variables:
@@ -102,4 +104,5 @@
         sig(nn, k) = sig1(i, k)
         w0(nn, k) = w01(i, k)
+        omega(nn, k) = omega1(i, k)
       END IF
     END DO
Index: /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2220)
@@ -6,4 +6,5 @@
     , clw, elij, evap, ep, epmlmmm, eplamm & ! RomP
     , wdtraina, wdtrainm &         ! RomP
+    , qtc, sigt          &
 
     , iflag1, kbas1, ktop1, precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, &
@@ -13,5 +14,6 @@
     , da1, phi1, mp1, phi21, d1a1, dam1, sigij1 & ! RomP+AC+jyg
     , clw1, elij1, evap1, ep1, epmlmmm1, eplamm1 & ! RomP
-    , wdtraina1, wdtrainm1) ! RomP
+    , wdtraina1, wdtrainm1 & ! RomP
+    , qtc1, sigt1)
 
   ! **************************************************************
@@ -56,4 +58,5 @@
   REAL evap(nloc, nd), ep(nloc, nd) !RomP
   REAL epmlmmm(nloc, nd, nd), eplamm(nloc, nd) !RomP+jyg
+  REAL qtc(nloc, nd), sigt(nloc, nd) !RomP
   REAL wdtraina(nloc, nd), wdtrainm(nloc, nd) !RomP
 
@@ -84,4 +87,5 @@
   REAL evap1(len, nd), ep1(len, nd) !RomP
   REAL epmlmmm1(len, nd, nd), eplamm1(len, nd) !RomP+jyg
+  REAL qtc1(len, nd), sigt1(len, nd) !RomP
   REAL wdtraina1(len, nd), wdtrainm1(len, nd) !RomP
 
@@ -141,4 +145,6 @@
       wdtraina1(idcum(i), k) = wdtraina(i, k) !RomP
       wdtrainm1(idcum(i), k) = wdtrainm(i, k) !RomP
+      qtc1(idcum(i), k) = qtc(i, k)
+      sigt1(idcum(i), k) = sigt(i, k)
 
     END DO
Index: /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2220)
@@ -3,5 +3,5 @@
 
 SUBROUTINE cv3p1_closure(nloc, ncum, nd, icb, inb, pbase, plcl, p, ph, tv, &
-    tvp, buoy, supmax, ok_inhib, ale, alp, sig, w0, ptop2, cape, cin, m, &
+    tvp, buoy, supmax, ok_inhib, ale, alp, omega,sig, w0, ptop2, cape, cin, m, &
     iflag, coef, plim1, plim2, asupmax, supmax0, asupmaxmin, cbmf, plfc, &
     wbeff)
@@ -37,4 +37,5 @@
   LOGICAL ok_inhib ! enable convection inhibition by dryness
   REAL ale(nloc), alp(nloc)
+  REAL omega(nloc,nd)
 
   ! input/output:
@@ -52,5 +53,5 @@
 
   ! local variables:
-  INTEGER il, i, j, k, icbmax, i0(nloc)
+  INTEGER il, i, j, k, icbmax, i0(nloc), klfc
   REAL deltap, fac, w, amu
   REAL rhodp
@@ -523,4 +524,13 @@
   END DO
 
+!CR:Compute k at plfc
+  DO k=1,nl
+     DO il=1,ncum
+        if ((plfc(il).lt.ph(il,k)).and.(plfc(il).ge.ph(il,k+1))) then
+           klfc=k
+        endif
+     ENDDO
+  ENDDO
+!RC
 
   DO il = 1, ncum
@@ -528,4 +538,10 @@
     ! c       cbmf1(il) = alp2(il)/(0.5*wb*wb-Cin(il))
     cbmf1(il) = alp2(il)/(2.*wbeff(il)*wbeff(il)-cin(il))
+!CR: Add large-scale component to the mass-flux
+!encore connu sous le nom "Experience du tube de dentifrice"
+    if (coef_clos_ls.gt.0.) then 
+       cbmf1(il) = cbmf1(il) - coef_clos_ls*min(0.,1./RG*omega(il,klfc))
+    endif
+!RC
     IF (cbmf1(il)==0 .AND. alp2(il)/=0.) THEN
       WRITE (lunout, *) 'cv3p1_closure cbmf1=0 and alp NE 0 il alp2 alp cin ' &
Index: /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2220)
@@ -7,5 +7,5 @@
                       u1, v1, tra1, &
                       p1, ph1, &
-                      Ale1, Alp1, &
+                      Ale1, Alp1, omega1, &
                       sig1feed1, sig2feed1, wght1, &
                       iflag1, ft1, fq1, fu1, fv1, ftra1, &
@@ -24,5 +24,6 @@
                       da1, phi1, mp1, phi21, d1a1, dam1, sigij1, wghti1, & ! RomP, RL
                       clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &        ! RomP, RL
-                      wdtrainA1, wdtrainM1)                                ! RomP
+                      wdtrainA1, wdtrainM1, qtc1, sigt1, tau_cld_cv, &
+                      coefw_cld_cv)                                        ! RomP, AJ
 ! **************************************************************
 ! *
@@ -55,4 +56,6 @@
 ! iflag_ice_thermo Integer        Input        accounting for ice thermodynamics (0/1)
 ! iflag_clos    Integer        Input        version of closure (0/1)
+! tau_cld_cv    Real           Input        characteristic time of dissipation of mixing fluxes
+! coefw_cld_cv  Real           Input        coefficient for updraft velocity in convection
 ! ok_conserv_q  Logical        Input        when true corrections for water conservation are swtiched on
 ! delt          Real           Input        time step
@@ -119,5 +122,6 @@
 ! phi1          Real           Output     used in tracer transport (cvltr)
 ! mp1           Real           Output     used in tracer transport (cvltr)
-                                         
+! qtc1          Real           Output     specific humidity in convection
+! sigt1         Real           Output     surface fraction in adiabatic updrafts                                         
 ! phi21         Real           Output     used in tracer transport (cvltr)
                                          
@@ -163,4 +167,6 @@
   INTEGER iflag_clos
   LOGICAL ok_conserv_q
+  REAL tau_cld_cv
+  REAL coefw_cld_cv
   REAL delt
   REAL t1(len, nd)
@@ -178,4 +184,5 @@
   REAL Ale1(len)
   REAL Alp1(len)
+  REAL omega1(len,nd)
   REAL sig1feed1 ! pressure at lower bound of feeding layer
   REAL sig2feed1 ! pressure at upper bound of feeding layer
@@ -225,4 +232,7 @@
   REAL asupmaxmin1(len)
   INTEGER lalim_conv(len)
+  REAL qtc1(len, nd)         ! cld
+  REAL sigt1(len, nd)        ! cld
+
 ! RomP >>>
   REAL wdtrainA1(len, nd), wdtrainM1(len, nd)
@@ -455,4 +465,5 @@
   REAL supmax(nloc, klev)
   REAL Ale(nloc), Alp(nloc), coef_clos(nloc)
+  REAL omega(nloc,klev)
   REAL sigd(nloc)
 ! real mp(nloc,klev), qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
@@ -487,4 +498,7 @@
   REAL hnk(nloc), unk(nloc), vnk(nloc)
 
+  REAL qtc(nloc, klev)         ! cld
+  REAL sigt(nloc, klev)        ! cld
+ 
 ! RomP >>>
   REAL wdtrainA(nloc, klev), wdtrainM(nloc, klev)
@@ -593,4 +607,6 @@
 
 ! RomP >>>
+  sigt1(:, :) = 0.
+  qtc1(:, :) = 0.
   wdtrainA1(:, :) = 0.
   wdtrainM1(:, :) = 0.
@@ -776,5 +792,5 @@
                          h1_wake, lv1_wake, lf1_wake, cpn1_wake, tv1_wake, &
                          sig1, w01, ptop21, &
-                         Ale1, Alp1, &
+                         Ale1, Alp1, omega1, &
                          iflag, nk, icb, icbs, &
                          plcl, tnk, qnk, gznk, hnk, unk, vnk, &
@@ -786,5 +802,5 @@
                          h_wake, lv_wake, lf_wake, cpn_wake, tv_wake, &
                          sig, w0, ptop2, &
-                         Ale, Alp)
+                         Ale, Alp, omega)
 
 ! print*,'tv ',tv
@@ -877,5 +893,5 @@
         CALL cv3p1_closure(nloc, ncum, nd, icb, inb, &         ! na->nd
                            pbase, plcl, p, ph, tv, tvp, buoy, &
-                           supmax, ok_inhib, Ale, Alp, &
+                           supmax, ok_inhib, Ale, Alp, omega, &
                            sig, w0, ptop2, cape, cin, m, iflag, coef_clos, &
                            Plim1, plim2, asupmax, supmax0, &
@@ -978,5 +994,5 @@
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
                      tls, tps, qcondc, wd, &
-                     ftd, fqd)
+                     ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
     END IF
 
@@ -1032,4 +1048,5 @@
                            clw, elij, evap, ep, epmlmMm, eplaMm, &       ! RomP
                            wdtrainA, wdtrainM, &                         ! RomP
+                           qtc, sigt, &
                            iflag1, kbas1, ktop1, &
                            precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, ptop21, &
@@ -1043,5 +1060,6 @@
                            da1, phi1, mp1, phi21, d1a1, dam1, sigij1,  & ! RomP
                            clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, & ! RomP
-                           wdtrainA1, wdtrainM1)                         ! RomP
+                           wdtrainA1, wdtrainM1,                       & ! RomP
+                           qtc1, sigt1)
     END IF
 
Index: /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2220)
@@ -8,5 +8,5 @@
      frac_impa, frac_nucl, beta,                        &
      prfl, psfl, rhcl, zqta, fraca,                     &
-     ztv, zpspsk, ztla, zthl, iflag_cldcon,             &
+     ztv, zpspsk, ztla, zthl, iflag_cldth,             &
      iflag_ice_thermo)
 
@@ -82,5 +82,5 @@
   INTEGER ninter ! sous-intervals pour la precipitation
   INTEGER ncoreczq  
-  INTEGER iflag_cldcon
+  INTEGER iflag_cldth
   INTEGER iflag_ice_thermo
   PARAMETER (ninter=5)
@@ -545,5 +545,5 @@
            enddo
 
-           if (iflag_cldcon>=5) then
+           if (iflag_cldth>=5) then
 
               call cloudth(klon,klev,k,ztv, &
@@ -559,11 +559,11 @@
            endif
 
-           if (iflag_cldcon <= 4) then
+           if (iflag_cldth <= 4) then
               lognormale = .true.
-           elseif (iflag_cldcon >= 6) then
+           elseif (iflag_cldth >= 6) then
               ! lognormale en l'absence des thermiques
               lognormale = fraca(:,k) < 1e-10
            else
-              ! Dans le cas iflag_cldcon=5, on prend systématiquement la
+              ! Dans le cas iflag_cldth=5, on prend systématiquement la
               ! bi-gaussienne
               lognormale = .false.
Index: /LMDZ5/branches/testing/libf/phylmd/hines_gwd.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/hines_gwd.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/hines_gwd.F90	(revision 2220)
@@ -625,5 +625,4 @@
     mmin_alpha, kstar, slope, f1, f2, f3, naz, levbot, levtop, il1, il2, &
     nlons, nlevs, nazmth, sigsqmcw, sigmatm, lorms, sigalpmc, f2mod)
-
   ! Smooth cutoff wavenumbers and total rms velocity in the vertical
   ! direction NSMAX times, using FLUX_U as temporary work array.
@@ -715,5 +714,5 @@
     i_alpha, mmin_alpha, kstar, slope, f1, f2, f3, naz, levbot, levtop, il1, &
     il2, nlons, nlevs, nazmth, sigsqmcw, sigmatm, lorms, sigalpmc, f2mod)
-
+  IMPLICIT NONE
   ! This routine calculates the cutoff vertical wavenumber and velocity
   ! variances on a longitude by altitude grid for the Hines' Doppler
@@ -766,5 +765,5 @@
 
   INTEGER naz, levbot, levtop, il1, il2, nlons, nlevs, nazmth
-  REAL slope, kstar(nlons), f1, f2, f3
+  REAL slope, kstar(nlons), f1, f2, f3, f2mfac
   REAL m_alpha(nlons, nlevs, nazmth)
   REAL sigma_alpha(nlons, nlevs, nazmth)
@@ -938,5 +937,5 @@
 SUBROUTINE hines_wind(v_alpha, vel_u, vel_v, naz, il1, il2, lev1, lev2, &
     nlons, nlevs, nazmth)
-
+    IMPLICIT NONE
   ! This routine calculates the azimuthal horizontal background wind
   ! components
@@ -1034,5 +1033,5 @@
     m_alpha, ak_alpha, k_alpha, slope, naz, il1, il2, lev1, lev2, nlons, &
     nlevs, nazmth, lorms)
-
+    IMPLICIT NONE
   ! Calculate zonal and meridional components of the vertical flux
   ! of horizontal momentum and corresponding wave drag (force per unit mass)
@@ -1089,5 +1088,5 @@
   ! Internal variables.
 
-  INTEGER i, l, lev1p, lev2m
+  INTEGER i, l, lev1p, lev2m, lev2p
   REAL cos45, prod2, prod4, prod6, prod8, dendz, dendz2
   DATA cos45/0.7071068/
@@ -1234,5 +1233,5 @@
     bvfreq, density, densb, sigma_t, visc_mol, kstar, slope, f2, f3, f5, f6, &
     naz, il1, il2, lev1, lev2, nlons, nlevs, nazmth)
-
+  IMPLICIT NONE
   ! This routine calculates the gravity wave induced heating and
   ! diffusion coefficient on a longitude by altitude grid for
@@ -1355,5 +1354,5 @@
 SUBROUTINE hines_sigma(sigma_t, sigma_alpha, sigsqh_alpha, naz, lev, il1, &
     il2, nlons, nlevs, nazmth)
-
+  IMPLICIT NONE
   ! This routine calculates the total rms and azimuthal rms horizontal
   ! velocities at a given level on a longitude by altitude grid for
@@ -1450,5 +1449,5 @@
 SUBROUTINE hines_intgrl(i_alpha, v_alpha, m_alpha, bvfb, slope, naz, lev, &
     il1, il2, nlons, nlevs, nazmth, lorms)
-
+  IMPLICIT NONE
   ! This routine calculates the vertical wavenumber integral
   ! for a single vertical level at each azimuth on a longitude grid
@@ -1643,5 +1642,5 @@
     alt_cutoff, smco, nsmax, iheatcal, k_alpha, ierror, nmessg, nlons, &
     nazmth, coslat)
-
+  IMPLICIT NONE
   ! This routine specifies various parameters needed for the
   ! the Hines' Doppler spread gravity wave drag parameterization scheme.
@@ -1772,5 +1771,5 @@
     sigma_alpha, v_alpha, m_alpha, iu_print, iv_print, nmessg, ilprt1, &
     ilprt2, levprt1, levprt2, naz, nlons, nlevs, nazmth)
-
+  IMPLICIT NONE
   ! Print out altitude profiles of various quantities from
   ! Hines' Doppler spread gravity wave drag parameterization scheme.
@@ -1864,5 +1863,5 @@
 SUBROUTINE hines_exp(data, data_zmax, alt, alt_exp, iorder, il1, il2, lev1, &
     lev2, nlons, nlevs)
-
+  IMPLICIT NONE
   ! This routine exponentially damps a longitude by altitude array
   ! of data above a specified altitude.
@@ -1941,5 +1940,5 @@
 SUBROUTINE vert_smooth(data, work, coeff, nsmooth, il1, il2, lev1, lev2, &
     nlons, nlevs)
-
+  IMPLICIT NONE
   ! Smooth a longitude by altitude array in the vertical over a
   ! specified number of levels using a three point smoother.
